PipeWire: impl-factory.h File Reference

PipeWire 0.3.5

Data Structures | Macros | Functions
impl-factory.h File Reference
Include dependency graph for impl-factory.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures
struct | pw_impl_factory_events
| Factory events, listen to them with pw_impl_factory_add_listener. More...
struct | pw_impl_factory_implementation

## Macros
#define | PW_VERSION_IMPL_FACTORY_EVENTS 0
#define | PW_VERSION_IMPL_FACTORY_IMPLEMENTATION 0

## Functions
struct pw_impl_factory * | pw_context_create_factory (struct pw_context *context, const char *name, const char *type, uint32_t version, struct pw_properties *properties, size_t user_data_size)
const struct pw_properties * | pw_impl_factory_get_properties (struct pw_impl_factory *factory)
| Get the factory properties. More...
const struct pw_factory_info * | pw_impl_factory_get_info (struct pw_impl_factory *factory)
| Get the factory info. More...
int | pw_impl_factory_update_properties (struct pw_impl_factory *factory, const struct spa_dict *dict)
| Update the factory properties. More...
int | pw_impl_factory_register (struct pw_impl_factory *factory, struct pw_properties *properties)
void | pw_impl_factory_destroy (struct pw_impl_factory *factory)
void * | pw_impl_factory_get_user_data (struct pw_impl_factory *factory)
struct pw_global * | pw_impl_factory_get_global (struct pw_impl_factory *factory)
| Get the global of this factory. More...
void | pw_impl_factory_add_listener (struct pw_impl_factory *factory, struct spa_hook *listener, const struct pw_impl_factory_events *events, void *data)
| Add an event listener. More...
void | pw_impl_factory_set_implementation (struct pw_impl_factory *factory, const struct pw_impl_factory_implementation *implementation, void *data)
void * | pw_impl_factory_create_object (struct pw_impl_factory *factory, struct pw_resource *resource, const char *type, uint32_t version, struct pw_properties *properties, uint32_t new_id)
struct pw_impl_factory * | pw_context_find_factory (struct pw_context *context, const char *name)
| Find a factory by name. More...

## Macro Definition Documentation

## ◆ PW_VERSION_IMPL_FACTORY_EVENTS

#define PW_VERSION_IMPL_FACTORY_EVENTS 0

## ◆ PW_VERSION_IMPL_FACTORY_IMPLEMENTATION

#define PW_VERSION_IMPL_FACTORY_IMPLEMENTATION 0

## Function Documentation

## ◆ pw_context_create_factory()

struct pw_impl_factory* pw_context_create_factory | ( | struct pw_context * | context,
|  | const char * | name,
|  | const char * | type,
|  | uint32_t | version,
|  | struct pw_properties * | properties,
|  | size_t | user_data_size
| ) |  |

References pw_properties::dict, NAME, pw_log::pw_log_debug, pw_properties::pw_properties_free(), pw_properties::pw_properties_new(), and res.

## ◆ pw_context_find_factory()

struct pw_impl_factory* pw_context_find_factory | ( | struct pw_context * | context,
|  | const char * | name
| ) |  |

Find a factory by name.

Parameters

  context | the context
  name | the factory name

## ◆ pw_impl_factory_add_listener()

void pw_impl_factory_add_listener | ( | struct pw_impl_factory * | factory,
|  | struct spa_hook * | listener,
|  | const struct pw_impl_factory_events * | events,
|  | void * | data
| ) |  |

Add an event listener.

## ◆ pw_impl_factory_create_object()

void* pw_impl_factory_create_object | ( | struct pw_impl_factory * | factory,
|  | struct pw_resource * | resource,
|  | const char * | type,
|  | uint32_t | version,
|  | struct pw_properties * | properties,
|  | uint32_t | new_id
| ) |  |

References res.

## ◆ pw_impl_factory_destroy()

void pw_impl_factory_destroy | ( | struct pw_impl_factory * | factory | ) |

References NAME, pw_global::pw_global_destroy(), pw_log::pw_log_debug, and pw_properties::pw_properties_free().

## ◆ pw_impl_factory_get_global()

struct pw_global* pw_impl_factory_get_global | ( | struct pw_impl_factory * | factory | ) |

Get the global of this factory.

## ◆ pw_impl_factory_get_info()

const struct pw_factory_info* pw_impl_factory_get_info | ( | struct pw_impl_factory * | factory | ) |

Get the factory info.

## ◆ pw_impl_factory_get_properties()

const struct pw_properties* pw_impl_factory_get_properties | ( | struct pw_impl_factory * | factory | ) |

Get the factory properties.

## ◆ pw_impl_factory_get_user_data()

void* pw_impl_factory_get_user_data | ( | struct pw_impl_factory * | factory | ) |

## ◆ pw_impl_factory_register()

int pw_impl_factory_register | ( | struct pw_impl_factory * | factory,
|  | struct pw_properties * | properties
| ) |  |

References pw_global::pw_global_new(), PW_KEY_FACTORY_NAME, PW_KEY_FACTORY_TYPE_NAME, PW_KEY_FACTORY_TYPE_VERSION, PW_KEY_MODULE_ID, pw_properties::pw_properties_new(), pw_properties::pw_properties_set(), pw_properties::pw_properties_setf(), pw_properties::pw_properties_update_keys(), PW_TYPE_INTERFACE_Factory, and PW_VERSION_FACTORY.

## ◆ pw_impl_factory_set_implementation()

void pw_impl_factory_set_implementation | ( | struct pw_impl_factory * | factory,
|  | const struct pw_impl_factory_implementation * | implementation,
|  | void * | data
| ) |  |

## ◆ pw_impl_factory_update_properties()

int pw_impl_factory_update_properties | ( | struct pw_impl_factory * | factory,
|  | const struct spa_dict * | dict
| ) |  |

Update the factory properties.

References NAME, PW_FACTORY_CHANGE_MASK_PROPS, pw_factory_resource_info, pw_log::pw_log_debug, and pw_properties::pw_properties_update().